package com.link.core.cache;

import com.google.common.cache.CacheBuilder;
import com.google.common.cache.CacheLoader;
import com.google.common.cache.LoadingCache;
import com.link.core.util.RedisUtil;
import com.link.core.util.redisclient.LinkRedisClient;
import java.time.Duration;
import java.util.Map;

public class CoreCacheUtil {
   private static LoadingCache<String, String> enterpriseCache = CacheBuilder.newBuilder().initialCapacity(20).maximumSize(500L).expireAfterWrite(Duration.ofDays(30L)).build(new CacheLoader<String, String>() {
      public String load(String key) {
         LinkRedisClient jedis = null;

         String valus;
         try {
            jedis = RedisUtil.getJedis();
            valus = jedis.get(key);
            if (valus == null) {
               valus = "";
            }
         } finally {
            RedisUtil.returnResource(jedis);
         }

         return valus;
      }
   });
   private static LoadingCache<String, String> authClientCache = CacheBuilder.newBuilder().initialCapacity(20).maximumSize(500L).expireAfterWrite(Duration.ofDays(30L)).build(new CacheLoader<String, String>() {
      public String load(String key) {
         LinkRedisClient jedis = null;

         String valus;
         try {
            jedis = RedisUtil.getJedis();
            valus = jedis.get(key);
            if (valus == null) {
               valus = "";
            }
         } finally {
            RedisUtil.returnResource(jedis);
         }

         return valus;
      }
   });
   private static LoadingCache<String, String> agentCache = CacheBuilder.newBuilder().initialCapacity(20).maximumSize(500L).expireAfterWrite(Duration.ofDays(30L)).build(new CacheLoader<String, String>() {
      public String load(String key) {
         LinkRedisClient jedis = null;

         String valus;
         try {
            jedis = RedisUtil.getJedis();
            valus = jedis.get(key);
            if (valus == null) {
               valus = "";
            }
         } finally {
            RedisUtil.returnResource(jedis);
         }

         return valus;
      }
   });
   private static LoadingCache<String, Map<String, String>> cfgPropertyCache = CacheBuilder.newBuilder().initialCapacity(20).maximumSize(1000L).expireAfterWrite(Duration.ofDays(1L)).build(new CacheLoader<String, Map<String, String>>() {
      public Map<String, String> load(String key) {
         LinkRedisClient jedis = null;

         Map valus;
         try {
            jedis = RedisUtil.getJedis();
            valus = jedis.hgetAll(key);
         } finally {
            RedisUtil.returnResource(jedis);
         }

         return valus;
      }
   });

   public static void refreshEnterpriseCache(String key) {
      enterpriseCache.refresh(key);
   }

   public static String getEnterpriseCache(String key) throws Exception {
      return (String)enterpriseCache.get(key);
   }

   public static void invalidateToken(String token) {
      enterpriseCache.invalidate(token);
   }

   public static void refreshAuthClientCache(String key) {
      authClientCache.refresh(key);
   }

   public static String getAuthClientCache(String key) throws Exception {
      return (String)authClientCache.get(key);
   }

   public static void invalidateAuthClientToken(String token) {
      authClientCache.invalidate(token);
   }

   public static void refreshAgentCache(String key) {
      agentCache.refresh(key);
   }

   public static String getAgentCache(String key) throws Exception {
      return (String)agentCache.get(key);
   }

   public static void invalidateAgentToken(String token) {
      agentCache.invalidate(token);
   }

   public static void refreshCfgPropertyCache(String key) {
      cfgPropertyCache.refresh(key);
   }

   public static Map<String, String> getCfgPropertyCache(String key) throws Exception {
      return (Map)cfgPropertyCache.get(key);
   }
}
